React Context Menu Wrapper
======

<p align="center">
  <a href="https://www.npmjs.com/package/chonky" target="_blank">
    <img alt="NPM package" src="https://img.shields.io/npm/v/react-context-menu-wrapper.svg">
  </a>
  <a href="https://tldrlegal.com/license/mit-license" style="margin-left: 5px;" target="_blank">
    <img alt="MIT license" src="https://img.shields.io/npm/l/react-context-menu-wrapper">
  </a>
  <a href="https://www.npmjs.com/package/react-context-menu-wrapper" style="margin-left: 5px;" target="_blank">
    <img alt="NPM downloads" src="https://img.shields.io/npm/dt/react-context-menu-wrapper">
  </a>
  <a href="https://github.com/TimboKZ/Chonky" style="margin-left: 5px;" target="_blank">
    <img alt="GitHub stars" src="https://img.shields.io/github/stars/TimboKZ/react-context-menu-wrapper">
  </a>
  <a href="https://discord.gg/HT4ttdQ" style="margin-left: 5px;" target="_blank">
    <img alt="Chat on Discord" src="https://img.shields.io/discord/696033621986770957?label=Chat%20on%20Discord">
  </a>
</p>

# Introduction

> **Important:** React Context Menu Wrapper v3+ uses [React hooks](https://reactjs.org/docs/hooks-intro.html) and
> functional components. If your project does not support them, consider 
> [using v2 or below](https://timbokz.github.io/react-context-menu-wrapper/v2/).

This library provides a simple wrapper for your context menus. It handles user interaction on desktop and mobile
devices, and guarantees correct context menu positioning.

In an effort to stay unopinionated, this library does not provide any styling or additional components. It is up to you
define your own styles and logic for the menu. This is useful when your CSS framework already provides dropdown menu
styling (e.g. [Bulma](https://bulma.io/), [Bootstrap](https://getbootstrap.com/)) or when you need to implement some
non-trivial logic for your context menu (e.g. [Ogma context menus](https://github.com/TimboKZ/Ogma) with tagging
support).

#### [View documentation and examples](https://timbokz.github.io/react-context-menu-wrapper/v3/)

## Preview

![Gif of the context menu library in action.](https://timbokz.github.io/react-context-menu-wrapper/v2/context-menu-shared.gif)

## Contributing

Please enable [ESLint](https://eslint.org/docs/user-guide/integrations) and
[Prettier](https://prettier.io/docs/en/editors.html) integration in your editor, and use the provided configs.

## License

MIT © [Tim K.](https://github.com/TimboKZ) 2020
